<template>
  <section v-if="activeProject" id="settings" class="section">
    <a class="button is-primary is-outlined" v-on:click="toggleModal()">Settings</a>

    <div v-on:keyup.esc="toggalModal()" class="modal" :class="{'is-active': showModal}">
      <div class="modal-background"></div>
      <div class="modal-card">
        <header class="modal-card-head">
          <p class="modal-card-title">Project Settings for: {{ activeProject.title }}</p>
          <button v-on:click="toggleModal()" class="delete" aria-label="close"></button>
        </header>
        <section class="modal-card-body">
          <div class="project_settings columns">
            <div class="column is-one-quarter">
              <aside class="menu">
                <p class="menu-label">Security</p>
                <ul class="menu-list">
                  <li>
                    <a>Client Keys</a>
                  </li>
                </ul>
              </aside>
            </div>
            <div class="column">
              <section class="section has-text-right">
                <div v-on:click="createCredentials()" class="button is-success">
                  <span class="icon">
                    <svg
                      role="img"
                      xmlns="http://www.w3.org/2000/svg"
                      width="48px"
                      height="48px"
                      viewBox="0 0 24 24"
                      aria-labelledby="plusIconTitle plusIconDesc"
                      stroke="#fff"
                      stroke-width="1.5"
                      stroke-linecap="square"
                      stroke-linejoin="miter"
                      fill="none"
                      color="#fff"
                    >
                      <title id="plusIconTitle">Add Credentials</title>
                      <desc id="plusIconDesc">Create new credentials</desc>
                      <path d="M20 12L4 12M12 4L12 20" />
                    </svg>
                  </span>
                </div>
              </section>
              <div v-if="projectClients && projectClients.length > 0">
                <ClientCredentials
                  v-for="client in projectClients"
                  :key="client.uuid"
                  :client="client"
                />
              </div>
              <div v-else>
                <div class="card">
                  <div class="card-content">
                    <p class="has-text-centered">No Client Credentials found</p>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </section>
        <footer class="modal-card-foot">
          <button class="button is-success">Save changes</button>
          <button class="button is-danger is-inverted" v-on:click="toggleModal()">Cancel</button>
        </footer>
      </div>
      <button v-on:click="toggleModal()" class="modal-close is-large" aria-label="close"></button>
    </div>
  </section>
</template>

<script lang="ts">
import { Component, Vue, Prop } from "vue-property-decorator";
import ClientCredentials from "@/components/ClientCredentials.vue";

@Component({
  components: { ClientCredentials }
})
export default class TheProjectSettingsModal extends Vue {
  showModal = false;

  toggleModal() {
    this.showModal = !this.showModal;
  }

  async createCredentials() {
    this.$store.dispatch("project/newClient");
  }

  get activeProject() {
    return this.$store.state.activeProject;
  }

  get projectClients() {
    return this.$store.state.project.clients;
  }
}
</script>

<style lang="scss" scoped>
.project_settings {
  background-color: $background;
}
</style>
